/*
 * $Id: pwrcheck.c 1 2005-01-26 16:01:45Z bmoore $
 *
 * Copyright (c) 2004  Branden J. Moore.
 *
 * This file is part of pwrcheck, and is free software; you can redistribute
 * it and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * pwrcheck is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with pwrcheck; if not, write to the Free Software Foundation, Inc., 59
 * Temple Place, Suite 330, Boston, MA  02111-1307 USA.
 *
 */

#include <stdio.h>

#include <IOKit/IOKitLib.h>
#include <IOKit/pwr_mgt/IOPMLib.h>
#include <IOKit/pwr_mgt/IOPM.h>
#include <CoreFoundation/CoreFoundation.h>
#include <mach/mach_init.h>


int main( int argc, char *argv[] )
{
	mach_port_t master;
	CFArrayRef cfarray;
	CFDictionaryRef dict;
	CFNumberRef cfnum;
	long flags;

	if ( IOMasterPort(bootstrap_port, &master ) == kIOReturnSuccess ) {
		if ( IOPMCopyBatteryInfo(master, &cfarray) == kIOReturnSuccess ) {
			dict = (CFDictionaryRef)CFArrayGetValueAtIndex(cfarray, 0);
			cfnum = (CFNumberRef)CFDictionaryGetValue(dict, CFSTR(kIOBatteryFlagsKey));
			CFNumberGetValue(cfnum, kCFNumberLongType, &flags);
			CFRelease(cfarray);

			if ( flags & kIOBatteryChargerConnect ) {
				return 0; /* On AC */
			} else {
				return 1; /* On Battery */
			}
		}
	}

	return 255;
}
